<?php

// http://php.net/manual/en/function.imagecreatefromjpeg.php
$image = imagecreatefromjpeg("nicolas-cage.jpg");

// http://www.php.net/manual/en/function.imagesx.php
$width = imagesx($image);
$height = imagesy($image);

// http://www.php.net/manual/en/function.imagecreatetruecolor.php
$poster = imagecreatetruecolor($width, $height);
$white = imagecolorallocate($poster, 255, 255, 255);

//loop through all the pixels of the image 
for($i=0; $i<$width; $i++)
{
	for($j=0; $j<$height; $j++)
	{
		// get color of a specific pixel
		//http://www.php.net/manual/en/function.imagecolorat.php
		$rgb = imagecolorat($image, $i, $j);
		
		
		$r = ($rgb >> 16) & 0xFF;    // bitwise shift right 16 places then AND with FF 
		$g = ($rgb >> 8) & 0xFF;     // bitwise shift right 8 places then AND with FF 
		$b =  $rgb & 0xFF;           // ANDing with FF (hex) 11111111  gives the last 
		
		if ($r >= 128){$r=255;}else{$r=0;}  //if it's more than half red, saturate red, otherwise 0 red
		if ($g >= 128){$g=255;}else{$g=0;}
		if ($b >= 128){$b=255;}else{$b=0;}
		
		// make reduced ("posterized") color
		$pc = imagecolorallocate($poster, $r, $g, $b);
		
		// fill in pixel in posterized image
		imagefilledrectangle($poster, $i, $j, $i+1, $j+1, $pc);
		
	}
}

// change the header
header('Content-Type: image/jpeg');
// Output the image
imagejpeg($poster);

?>